/*

Author: Roger Villela
Newsletter e-mail: RogerVillelaJournal@OpenMind.OnMicrosoft.com
LinkedIn: https://www.linkedin.com/in/rogervillela
Products: Microsoft Visual Studio / Microsoft Visual C++

MATERIAL PARA USO EDUCACIONAL E INFORMATIVO

O uso deste projeto e outros materiais fornecidos e apresentados por mim, so dedicados exclusivamente
para uso educacional atravs de cursos de minha autoria, os quais apresento em todo territrio nacional e
internacional atravs de variados meios de comunicao e distribuio, como documentos eletrnicos e impressos,
redes sociais e grupos compatveis com o propsito, como blogs e outros tipos de sites para apresentao de contedo,
conferncias atravs do produto Microsoft Skype (Copyright - All Rights Reserved) e outros que sejam teis ao
propsito educacional. O autor no se responsabiliza, direta ou indiretamente, pelo uso feito por terceiros deste produto.


SOFTWARES && TECNOLOGIAS


==> Programming Languages

-> C++
-> C++/CLI (Common Language Infrastructure)
-> C++/CX (Component Extensions)
-> C++/WinRT (Windows Runtime)
-> C#

==> Windows OS Platform

-> Microsoft Windows 10 (Spring Creators Update)
-> Microsoft Windows 10 (Fall Creators Update)
-> Microsoft Windows 10 (Creators Update)

==> CLR (Common Language Runtime) Platform

==> WinRT (Windows Runtime) Platform

==> Libraries

-> Microsoft UCRT - Universal C Runtime
-> Microsoft CRT - C Runtime
-> WinRT Libraries
-> Windows API's
-> BCL - Base Class Library
-> FCL - Framework Class Library (outro nome pelo qual a BCL  conhecida / citada em documentao)


==> Microsoft Visual Studio 2017 (Microsoft Visual C++, Microsoft Visual C#)

-> 15.7.n
-> 15.6.n
-> 15.5.n
-> 15.4.n
-> 15.3.n
-> 15.2.n
-> 15.0.n

==> Microsoft Windows SDK(s) (incluindo atualizaes)

-> 10.0.16299.n (Microsoft Windows 10 Fall Creators Update)
-> 10.0.15063.n (Microsoft Windows 10 Creators Update)
-> 10.0.15052.n
-> 10.0.14965.n
-> 10.0.14393.n
-> 10.0.10586.n
-> 10.0.10240.n


OBSERVAES


Microsoft Visual Studio C++

-> O cdigo fundamental compila com outras verses do Microsoft Visual C++, desde que haja suporte para os recursos
utilizados nos cdigos e arquivos diretamente relacionados. Mas o arquivo de projeto ( vcxproj ) pode ser 	incompatvel
em funo de mudanas realizadas atravs das verses/updates.
-> As opes de compilao tambm podem variar entre verses/updates. Caso utilize uma outra verso/update
do Microsoft Visual C++, ajustes podem ser necessrios.


Microsoft Visual C#

-> O cdigo fundamental compila com outras verses do Microsoft Visual C#, desde que haja suporte para os recursos
utilizados nos cdigos e arquivos diretamente relacionados. Mas o arquivo de projeto ( csproj ) pode ser 	incompatvel
em funo de mudanas realizadas atravs das verses/updates.
-> As opes de compilao tambm podem variar entre verses/updates. Caso utilize uma outra verso/update
do Microsoft Visual C#, ajustes podem ser necessrios.


Microsoft Windows SDK

-> Os projetos de exemplo sempre so distribudos e configurados para uso da verso mais recente do Microsoft Windows SDK ( RTM )
para Microsoft Windows 10. No entanto, so compatveis com o Microsoft Windows SDK 10.0.10240.0 em diante.
-> O cdigo fundamental tambmcompila com outras verses do Windows SDK. No entanto, adaptaes podem ser necessrias em funo
de opes de compilao e suporte para recursos nas libraries e header files.


PROPSITO


Funes de suporte para tratamento de erro, apresentao de mensagens e
obteno de informaes sobre o ambiente/contexto de execuo.


DETALHES

A maneira como um programa  organizado em arquivos ajuda a enfatizar sua estrutura lgica,
ajuda a compreenso humana e tambm ajuda o compilador a enfatizar essa organizao lgica.
Quando um arquivo de cdigo  informado ao compilador, ele  macro processado e as diretivas #include
so apresentadas atravs de header files. O resultado dessa atividade  a chamada translation unit.
Essa translation unit  o que o compilador de fato trabalha com e o que as regras da linguagem descrevem.
No importando a quantidade de arquivos, todos devem respeitar as regras da linguagem e o compilador
enfatiza isto. Aps a compilao o linker, vai unir essas partes para que um ou mais arquivos binrios possam ser
criados. O linker tambm verifica uma srie de regras para garantir que nenhuma delas tenha sido violada.


*/




/*

Smbolo para impedir o erro LNK2005: Duplicate Symbol.

Essa  a tcnica utilizada pelos profissionais no mundo inteiro para evitar este problema associado
com a maneira como  o linker C/C++ lida com um header file includo em mais de um arquivo C/C++ ou
quando um header file  includo em outro header file.
Essa tcnica  utilizada com header files para qualquer compilador em qualquer sistema operacional.
Essa tcnica  chamada de INCLUDE GUARDS.

Soluo para o warning LNK4042

Veja neste link:
http://stackoverflow.com/questions/3695174/visual-studio-2010s-strange-warning-lnk4042

*/

#pragma once

#pragma region Warnings
#pragma endregion

#pragma region Header files
#include <RVJ.h>
#pragma endregion

#pragma region Importing APIs 

namespace Windows {
	namespace Consoles {

		//__declspec( dllimport ) void AppendFormatted( const char16_t* const formatString, char16_t* values );

		#pragma region Pause and wait the user press <ENTER>
		__declspec( dllimport ) void Pause( bool pause );
		#pragma endregion

		#pragma region Show messages on a console window
		__declspec( dllimport ) void WriteMessage( const char16_t* buffer, ... );
		#pragma endregion

		#pragma region Get and show last error
		__declspec( dllimport ) void LastError();
		#pragma endregion

	};
};
#pragma endregion

